<template>
  <div class="d-f facsimile">
    <div class="facsimile__steps">
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>1</span>
          </div>
          <div class="text">
            Отсканируйте любой документ <br/>
            с нужной подписью и печатью <br/>
            в формате png или jpg
          </div>
        </div>
        <!--<div class="link">-->
        <!--Скачать бланк-пустографку-->
        <!--</div>-->
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>2</span>
          </div>
          <div class="text">
            Откройте полученный скан в любом <br/>
            приложении, позволяющем <br/>
            вырезать часть картинки. Например, <br/>
            в стандартной программе <br/>
            просмотра картинок Windows <br/>
            или Mac
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>3</span>
          </div>
          <div class="text">
            Вырежьте две отдельных <br/>
            квадратных картинки: одну <br/>
            с подписью, другую с печатью
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>4</span>
          </div>
          <div class="text">
            Cохраните вырезанные картинки <br/>
            в формате png или jpg
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>5</span>
          </div>
          <div class="text">
            Перетащите картинки с подписью <br/>
            и печатью в соответствующие <br/>
            области справа
          </div>
        </div>
      </div>
      <div class="facsimile__steps--step">
        <div class="top">
          <div class="num">
            <span>6</span>
          </div>
          <div class="text">
            Проверьте получившиеся <br/>
            изображения факсимиле
          </div>
        </div>
      </div>
    </div>
    <div class="facsimile__images">
      <div class="facsimile__images--title">
        Ваши факсимиле
      </div>
      <div class="facsimile__images--line">
        <div class="facsimile__images--line-item">
          <div class="text">Подпись</div>
          <div v-if="facsimile.signatureUuid">
            <div :style="'background-image: url(' + signatureImage + ');'"
                 class="image">
            </div >
            <div class="facsimile__images--delete">
              <div @click="clearFacsimile(facsimile.signatureUuid, 'signature')"
                   class="delete">
                Удалить подпись
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
              data-qa="uploader"
              label="Перетащите сюда картинку с подписью или нажмите"
              :multiple="false"
              @change="onUploadFile($event, 'signature')"
            />
          </div>
        </div>
        <div class="facsimile__images--line-item">
          <div class="text">Печать</div>
          <div v-if="facsimile.stampUuid">
            <div :style="'background-image: url(' + stampImage + ');'"
                 class="image">
            </div>
            <div class="facsimile__images--delete">
              <div @click="clearFacsimile(facsimile.stampUuid, 'stamp')"
                   class="delete">
                Удалить печать
              </div>
            </div>
          </div>
          <div v-else>
            <ob-uploader
              data-qa="uploader"
              label="Перетащите сюда картинку с подписью или нажмите"
              :multiple="false"
              @change="onUploadFile($event, 'stamp')"
            />
          </div>

        </div>
      </div>
      <div v-if="facsimile.signatureUuid || facsimile.stampUuid"
           class="facsimile__images--delete">
        <div class="text">
          Чтобы заменить факсимиле, просто перетащите новую картинку <br/>
          поверх старой или удалите старую картинку и загрузите новую
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ObUploader from 'common-components/src/obComponents/obUploader'
import {mapActions, mapGetters} from "vuex";
import api from "@/api";

export default {
  name: "facsimile",
  components:{
    ObUploader
  },
  computed:{
    ...mapGetters({
      userUuid: 'user/participantUuid',
      facsimile: 'clicarSettings_2/facsimile',
      signatureImage: 'clicarSettings_2/signatureImage',
      stampImage: 'clicarSettings_2/stampImage',
      role: 'user/role'
    })
  },
  methods:{
    ...mapActions({
      getFacsimile: 'clicarSettings_2/getFacsimileOld',
      getFacsimileForClicar: 'clicarSettings_2/getFacsimileForClicar'
    }),
    async onUploadFile(data, type) {
      console.log('!!!!!')
      data = data[0]
      const jsonData = {
        filename: data.file.name,
        participant_uuid: this.userUuid,
      };
      const form = new FormData();
      form.append('jsonData', JSON.stringify(jsonData));
      form.append('file', data.file);
      await api.clicar_setting_2.postFacsimile(data.uuid, form).then(() => {
        if (type === 'signature') {
          if (this.role === 'carrier') {
            api.clicar_setting_2.putFacsimileSignature(this.userUuid, data.uuid)
          } else if (this.role === 'clicar') {
            api.clicar_setting_2.putFacsimileSignatureForClicar(this.userUuid, data.uuid)
          }
        }
        else if (type === 'stamp') {
          if (this.role === 'carrier') {
            api.clicar_setting_2.putFacsimileStamp(this.userUuid, data.uuid)
          } else if (this.role === 'clicar') {
            api.clicar_setting_2.putFacsimileStampForClicar(this.userUuid, data.uuid)
          }

        }
        setTimeout(()=>{
          this.getFacsimile(this.userUuid)
        },500)
      })
    },

    clearFacsimile(uuid, type){
      if (type === 'signature') {
        if (this.role === 'carrier') {
          api.clicar_setting_2.deleteFacsimileSignature(this.userUuid).then(() => {
            api.files.deleteFile(uuid)
          })
        } else if (this.role === 'clicar') {
          api.clicar_setting_2.deleteFacsimileSignatureForClicar(this.userUuid).then(() => {
            api.files.deleteFile(uuid)
          })
        }
      }
      else if (type === 'stamp') {


        if (this.role === 'carrier') {
          api.clicar_setting_2.deleteFacsimileStamp(this.userUuid).then(() => {
            api.files.deleteFile(uuid)
          })
        } else if (this.role === 'clicar') {
          api.clicar_setting_2.deleteFacsimileStampForClicar(this.userUuid).then(() => {
            api.files.deleteFile(uuid)
          })
        }
      }
      setTimeout(() => {
        this.getFacsimile(this.userUuid)
      },500)
    }
  },
  mounted() {
    if (this.role === 'carrier') {
      this.getFacsimile(this.userUuid);
    } else if (this.role === 'clicar') {
      this.getFacsimileForClicar(this.userUuid);
    }
  }
}
</script>

<style scoped lang="scss">
@import '~common-components/src/static/css/mixins';
.facsimile {
  margin: 30px;
  &__steps {
    padding-right: 40px;
    border-right: 1px $blue-150 solid;
    &--step {
      margin-bottom: 40px;
      .top {
        display: flex;
        .num {
          min-width: 36px;
          width: 36px;
          height: 36px;
          display: flex;
          align-items: center;
          justify-content: center;
          border: 2px solid $color-blue-smalt;
          border-radius: 20px;
          margin-right: 20px;
          @include font-mixin(16px, 19px, 700, $color-blue-smalt);
        }
        .text {
          @include font-mixin(16px, 20px, 400);
        }
      }
      .link {
        cursor: pointer;
        margin: 10px 0 0 56px;
        @include font-mixin(16px, 20px, 400, $color-blue-smalt);
      }
    }
  }
  &__images {
    padding-left: 40px;
    &--title {
      @include font-mixin(20px, 28px, 700);
    }
    &--line {
      display: flex;
      margin-top: 30px;
      .mt40 {
        margin-top: 40px!important;
      }
      &-item {
        width: 198px;
        margin-right: 20px;
        .text {
          margin-bottom: 10px;
          @include font-mixin(16px, 20px, 400);
        }
        .image {
          width: 198px;
          height: 198px;
          display: flex;
          align-items: center;
          justify-content: center;
          text-align: center;
          border: 1px dashed $obUploader-body_border_color;
          background-size: contain;
          background-position: center center;
          background-repeat: no-repeat;
          @include font-mixin(12px, 18px, 400, $color-grey-label);
        }
      }
    }
    &--delete {
      margin-top: 10px;
      .delete {
        @include font-mixin(14px, 18px, 400, $color-error);
        cursor: pointer;
      }
      .text {
        margin-top: 30px;
        @include font-mixin(12px, 14px, 400, $gray-slate);
      }
    }
  }
}
::v-deep .ob-uploader-body{
  width: 198px;
  height: 198px;
  display: flex;
  align-items: center;
  justify-content: center;
  text-align: center;
  border: 1px dashed $obUploader-body_border_color;
  @include font-mixin(12px, 18px, 400, $color-grey-label);
}
</style>
